# TODO, sometime: JACK, polypaudio, toolame, twolame, libdts, x264

%define		cvs 20060513
%define 	_without_xmms 1
%define 	_with_samba 1
Name:           mplayer
Version:        1.0
Release:        0.39.%{cvs}.2%{?dist}
Summary:        Movie player playing most video formats and DVDs
Epoch:		1

Group:          Applications/Multimedia
License:        GPL
URL:            http://www.mplayerhq.hu/
# cvs -z3 -d:pserver:anonymous@mplayerhq.hu:/cvsroot/mplayer ex -D $cvs \
#   -d MPlayer-$cvs main && tar jcf MPlayer-$cvs.tar.bz2 MPlayer-$cvs
Source0:        http://cachalot.mine.nu/src/misc/MPlayer-%{cvs}.tar.bz2
Source1:        http://www.mplayerhq.hu/MPlayer/Skin/Blue-1.5.tar.bz2
Patch0:         MPlayer-0.90pre9-runtimemsg.patch
Patch1:         mplayer-1.0cvs20060407-redhat.patch
Patch4:         MPlayer-0.90-playlist.patch
Patch5:         mplayer-asm-x86_64.patch
Patch13:        mplayer-1.0cvs20060412-mp3lib3dnowext.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  alsa-lib-devel, %{__perl}, libmpcdec-devel
BuildRequires:  SDL-devel, freetype-devel >= 2.0.9, fribidi-devel
BuildRequires:  libvorbis-devel, libogg-devel, esound-devel, openal-devel
BuildRequires:  xvidcore-devel >= 0.9.2, arts-devel, libdvdread-devel
BuildRequires:  cdparanoia-devel, libmad-devel
BuildRequires:  libpng-devel, libdv-devel, lzo-devel, libjpeg-devel
BuildRequires:  libungif-devel, zlib-devel, live-devel
BuildRequires:  libtheora-devel
BuildRequires:  enca-devel libXv-devel fontconfig-devel libXxf86vm-devel
BuildRequires:  libXinerama-devel mesa-libGL-devel libXvMC-devel
BuildRequires:  glibc-kernheaders >= 2.4-9.1.94
%{?_with_samba:BuildRequires: samba-common}
%{!?_without_xmms:BuildRequires: xmms-devel}
# For CVS snapshot builds:
BuildRequires:  ffmpeg-devel >= 0.4.9-0.21.cvs20060407
BuildRequires:  libxslt, docbook-style-xsl

%description
MPlayer is a movie player that plays most MPEG, VOB, AVI, OGG/OGM,
VIVO, ASF/WMA/WMV, QT/MOV/MP4, FLI, RM, NuppelVideo, yuv4mpeg, FILM,
RoQ, and PVA files. You can also use it to watch VCDs, SVCDs, DVDs,
3ivx, RealMedia, and DivX movies.
It supports a wide range of output drivers including X11, XVideo, DGA,
OpenGL, SVGAlib, fbdev, AAlib, DirectFB etc. There are also nice
antialiased shaded subtitles and OSD.
Non-default rpmbuild options:
--with samba:   Enable Samba (smb://) support
--without xmms: Disable XMMS input plugin support

%package gui
Summary:        GUI for MPlayer
Group:          Applications/Multimedia
Requires:       mplayer = %{epoch}:%{version}-%{release}
BuildRequires:  gtk2-devel

%description gui
This package contains a GUI for MPlayer. The package includes a
the default skin for the GUI.

%package -n mencoder
Summary:        MPlayer movie encoder
Group:          Applications/Multimedia
BuildRequires:  lame-devel
Requires:       mplayer = %{epoch}:%{version}-%{release}
Provides:       mplayer-mencoder = %{version}-%{release}
Obsoletes:      mplayer-mencoder < 1.0-0.36

%description -n mencoder
This package contains the MPlayer movie encoder. 

%package doc
Summary:        MPlayer documentation in various languages
Group:          Documentation

%description doc
MPlayer documentation in various languages.


%prep
%setup -q -n MPlayer-%{cvs}
find . -name .cvsignore | xargs -r rm -f
# CVS/Entries for version.sh
mkdir CVS ; touch -r $(ls -1 --sort=time | head -n 1) CVS/Entries
%patch0 -p1 -b .runtimemsg
%patch1 -p0 -b .redhat
%patch4 -p1 -b .playlist
%patch5 -p0 -b .asm-x86_64
%patch13

iconv -f iso-8859-1 -t utf-8 AUTHORS > AUTHORS.utf8 ; mv AUTHORS.utf8 AUTHORS
for l in cs de en es fr it sv; do
  iconv -f iso-8859-1 -t utf-8 < DOCS/man/$l/mplayer.1 \
    > DOCS/man/mplayer.1.$l.utf8
done
for l in cs hu pl; do
  iconv -f iso-8859-2 -t utf-8 < DOCS/man/$l/mplayer.1 \
    > DOCS/man/mplayer.1.$l.utf8
done
iconv -f gbk -t utf-8 < DOCS/man/zh/mplayer.1 > DOCS/man/mplayer.1.zh_TW.utf8

sed -i -e 's/-$1/-rpm.livna.org-$1/' version.sh


%build
export CFLAGS="$RPM_OPT_FLAGS -ffast-math"
%ifarch ppc
export CFLAGS="$CFLAGS -maltivec -mabi=altivec"
%endif
./configure \
  --cc="%{__cc}" \
  --prefix=%{_prefix} \
  --libdir=%{_libdir} \
  --datadir=%{_datadir}/mplayer \
  --confdir=%{_sysconfdir}/mplayer \
  --mandir=%{_mandir} \
  --enable-gui \
  --enable-menu \
  --enable-mencoder \
  --enable-largefiles \
%ifarch %ix86
  --target=%{_target_platform} \
  --enable-win32 \
  --with-win32libdir=%{_libdir}/win32 \
  --with-reallibdir=%{_libdir}/win32 \
%endif
  --enable-joystick \
  --disable-mpdvdkit \
  --enable-xvmc \
  --with-xvmclib=XvMCW \
  --enable-enca \
  --with-cdparanoiaincdir=%{_includedir}/cdda \
  --enable-libdv \
  --enable-live \
  --with-livelibdir=%{_libdir}/live \
%if 0%{!?_without_xmms:1}
  --enable-xmms \
  --with-xmmslibdir=%{_libdir} \
%endif
  --enable-runtime-cpudetection \
  --enable-fribidi \
  --with-x11libdir=%{_libdir} \
%{!?_with_samba: --disable-smb} \
  --disable-termcap \
  --disable-svga \
  --disable-libfame

# 1.0pre[5..7] is not parallel build clean (dxr3/dha/libmpdemux)
make

if [ ! -e doc/HTML ] ; then
  cd DOCS/xml && ./configure && make && cd ../..
fi


%install
rm -rf $RPM_BUILD_ROOT doc

make install DESTDIR=$RPM_BUILD_ROOT STRIPBINARIES=no

# Take care of manual pages. These are in multiple languages, and there
# is one common manual page for both mplayer and mencoder.

echo ".so man1/mplayer.1" > DOCS/man/rlo-mencoder.1

install -dm 755 $RPM_BUILD_ROOT%{_mandir}/man1
install -m 644 DOCS/man/mplayer.1.en.utf8 \
  $RPM_BUILD_ROOT%{_mandir}/man1/mplayer.1
install -pm 644 DOCS/man/rlo-mencoder.1 \
  $RPM_BUILD_ROOT%{_mandir}/man1/mencoder.1
for l in cs de es fr hu it pl sv zh_TW; do
  install -dm 755 $RPM_BUILD_ROOT%{_mandir}/$l/man1
  install -m 644 DOCS/man/mplayer.1.$l.utf8 \
    $RPM_BUILD_ROOT%{_mandir}/$l/man1/mplayer.1
  install -pm 644 DOCS/man/rlo-mencoder.1 \
    $RPM_BUILD_ROOT%{_mandir}/$l/man1/mencoder.1
done

# Clean up documentation
mkdir doc
cp -pR DOCS/* doc/
rm -r doc/man doc/xml doc/README
cp -pR doc/HTML/* doc/
rm -r doc/HTML

# Install the rest of the configuration files after making a few
# changes in them.
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/mplayer
%{__perl} -pe \
  's|^\#include = .*|\#include = /home/me/.mplayer/something|;
   s|/usr/local/etc/mplayer\.conf|%{_sysconfdir}/mplayer/mplayer.conf|;
   s|/usr/local/share/|%{_datadir}/|;
   s|^#ao=oss.*$|ao=alsa|;' \
  etc/example.conf > $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/mplayer.conf
chmod 644 $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/mplayer.conf
install -pm 644 etc/{input,menu}.conf $RPM_BUILD_ROOT%{_sysconfdir}/mplayer/

# Fix permissions on default skin for gmplayer and install.
mkdir skins
tar -C skins -xjf %{SOURCE1}
find skins -type d -exec chmod 755 {} \;
find skins -type f -exec chmod 644 {} \;
find skins -type f -name "README" -exec rm {} \;
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/mplayer/Skin
cp -a skins/* $RPM_BUILD_ROOT%{_datadir}/mplayer/Skin/
ln -s Blue $RPM_BUILD_ROOT%{_datadir}/mplayer/Skin/default

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
mv $RPM_BUILD_ROOT%{_datadir}/pixmaps/mplayer.xpm \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps

install -dm 755 $RPM_BUILD_ROOT%{_libdir}/win32


%post -p /sbin/ldconfig

%post gui
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &>/dev/null || :

%postun -p /sbin/ldconfig

%postun gui
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &>/dev/null || :


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root, -)
%doc AUTHORS ChangeLog LICENSE README
%dir %{_sysconfdir}/mplayer
%config(noreplace) %{_sysconfdir}/mplayer/mplayer.conf
%config(noreplace) %{_sysconfdir}/mplayer/input.conf
%config(noreplace) %{_sysconfdir}/mplayer/menu.conf
%{_bindir}/mplayer
%{_libdir}/libdha.so.*
%{_libdir}/mplayer/
%dir %{_libdir}/win32/
%dir %{_datadir}/mplayer/
%{_mandir}/man1/mplayer.1*
%lang(cs) %{_mandir}/cs/man1/mplayer.1*
%lang(de) %{_mandir}/de/man1/mplayer.1*
%lang(es) %{_mandir}/es/man1/mplayer.1*
%lang(fr) %{_mandir}/fr/man1/mplayer.1*
%lang(hu) %{_mandir}/hu/man1/mplayer.1*
%lang(it) %{_mandir}/it/man1/mplayer.1*
%lang(pl) %{_mandir}/pl/man1/mplayer.1*
%lang(sv) %{_mandir}/sv/man1/mplayer.1*
%lang(zh_TW) %{_mandir}/zh_TW/man1/mplayer.1*

%files gui
%defattr(-, root, root, -)
%{_bindir}/gmplayer
%{_datadir}/applications/*mplayer.desktop
%{_datadir}/icons/hicolor/32x32/apps/mplayer.xpm
%{_datadir}/mplayer/Skin/

%files -n mencoder
%defattr(-, root, root, -)
%{_bindir}/mencoder
%{_mandir}/man1/mencoder.1*
%lang(cs) %{_mandir}/cs/man1/mencoder.1*
%lang(de) %{_mandir}/de/man1/mencoder.1*
%lang(es) %{_mandir}/es/man1/mencoder.1*
%lang(fr) %{_mandir}/fr/man1/mencoder.1*
%lang(hu) %{_mandir}/hu/man1/mencoder.1*
%lang(it) %{_mandir}/it/man1/mencoder.1*
%lang(pl) %{_mandir}/pl/man1/mencoder.1*
%lang(sv) %{_mandir}/sv/man1/mencoder.1*
%lang(zh_TW) %{_mandir}/zh_TW/man1/mencoder.1*

%files doc
%defattr(-, root, root, -)
%doc doc/default.css doc/en doc/tech
%lang(de) %doc doc/de
%lang(es) %doc doc/es
%lang(fr) %doc doc/fr
%lang(hu) %doc doc/hu
%lang(hu) %doc doc/it
%lang(pl) %doc doc/pl
%lang(ru) %doc doc/ru
%lang(ru) %doc doc/zh


%changelog
* Tue May 23 2006 Rafal Kwasny <rkwasny@aurox.org> - 1.0-0.39.20060513
- rebuild for Aurox
- added Obsoletes
- drop out mplayer-fonts due to licensing
- add epoch

* Sat May 13 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.39.20060513
- 2006-05-13 CVS snapshot.
- Make audio output default to ALSA in default config (#970).
- Trim pre-2005 %%changelog entries.

* Sat May 06 2006 Noa Resare <noa@resare.com>
- Move doc to a separate package (#960).

* Sun Apr 16 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.39.20060412
- Enable Musepack support.

* Thu Apr 13 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.38.20060412
- 2006-04-12 CVS snapshot.
- Fix 3dnow disabling patch, some parts were erroneously omitted in the
  previous revision (Thomas Jansen).

* Sat Apr  8 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.38.20060407
- 2006-04-07 CVS snapshot using shared ffmpeg, GTK2, FAAC, OpenAL, and XvMC.
- XMMS input plugin support can be disabled by rebuilding with "--without xmms"
- GUI changes: use upstream desktop entry file, update GTK icon cache and
  desktop database at post(un)install time, install icon to %%{_datadir}/icons.
- Drop lots of obsolete patches.

* Fri Mar 24 2006 Andreas Bierfert <andreas.bierfert[AT]lowlatency.de>
1.0-0.37.pre7try2
- fix #836
- fix #835,#834 by disabling detection of 3dnowext for now (Thomas Jansen)
  this should work around the garbage sound output

* Sat Mar 18 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.36.pre7try2
- Add RLO identifier to version string per upstream recommendation.
- Use configure flags instead of patch for enabling v4l*.
- Make DVB and DirectFB support unconditional.
- Drop libXvMC-devel build dependency until xvmc is actually built (#731).
- Backport get_time_pos slave mode command from CVS to fix progress bar
  with mplayerplug-in >= 3.15.
- Drop vdr-mplayer slave mode patch.
- Rename mplayer-mencoder to mencoder.

* Fri Mar 17 2006 Andreas Bierfert <andreas.bierfert[AT]lowlatency.de>
1.0-0.35.pre7try2
- fix x86_64 asm issues (maybe?!)
- fix file section for ppc

* Thu Mar 09 2006 Andreas Bierfert <andreas.bierfert[AT]lowlatency.de>
- switch to new release field

* Tue Feb 28 2006 Andreas Bierfert <andreas.bierfert[AT]lowlatency.de>
- add dist

* Thu Feb 23 2006 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.lvn.0.34.pre7try2
- Apply upstream demuxer.h heap overflow fix (CVE-2006-0579).
- Fix build time X11 detection on lib64 archs.
- Update Blue skin to 1.5.

* Mon Jan 16 2006 Adrian Reber <adrian@lisas.de> - 1.0-0.lvn.0.32.pre7try2
- re-enabled the aalib-devel BR

* Thu Dec 22 2005 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.lvn.0.31.pre7try2
- Apply fix for CVE-2005-4048 from ffmpeg CVS.

* Sun Dec 11 2005 Adrian Reber <adrian@lisas.de> - 1.0-0.lvn.0.30.pre7try2
- changed BR for modular X
- temporary removal of aalib-devel BR

* Fri Nov 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.lvn.0.29.pre7try2
- More pre-FC3 cleanups.
- Make "Blue" the default skin by symlinking, fixes fallback (#571).
- Build against new DirectFB.

* Thu Sep 29 2005 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.lvn.0.28.pre7try2
- Clean up obsolete pre-FC3 stuff (LIRC, CACA, DXR3, and Enca support now
  unconditional).
- Drop zero Epochs.

* Thu Sep 15 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.lvn.0.27.pre7try2
- Enable Enca by default, build with it for FC3+.

* Tue Sep  6 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.lvn.0.26.pre7try2
- 1.0pre7try2.
- Enable v4l2 interface (#576).
- Enable DVB support only with recent enough glibc-kernheaders.

* Mon Jul  4 2005 Thorsten Leemhuis <fedora at leemhuis.info> - 0:1.0-0.lvn.0.26.pre7
- Add a patch to allow compiling for x86_64-FC4; thx to Ryo Dairiki:
  https://www.redhat.com/archives/fedora-extras-list/2005-July/msg00997.html

* Mon Jul  4 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.lvn.0.25.pre7
- Enable DirectFB by default, rebuild with "--without directfb" to disable.
- Clean up obsolete pre-FC2 support.

* Thu Jun 30 2005 Dams <anvil[AT]livna.org> - 0:1.0-0.lvn.0.24.pre7
- Added patch to fix ppc/altivec builds (#494)

* Mon Jun 20 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.lvn.0.23.pre7
- Completely disable parallel make for now.

* Mon Jun  6 2005 Thorsten Leemhuis <fedora at leemhuis.info> - 0:1.0-0.lvn.0.22.pre7
- add gcc4 patch from thias/gentoo/myself

* Mon May  9 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.lvn.0.21.pre7
- Use em8300-devel for DXR3 support, and make it optional, default enabled.

* Tue May 03 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:1.0-0.lvn.0.20.pre7
- fix build issues on x86_64:
 - move target= to a ix86 section -- on x86_64 it passes the option x86-64 
   and not x86_64
 - use explicit --with-xmmslibdir
 - {_libdir}/libdha.so.* and {_libdir}/mplayer are missing on x86_64

* Tue Apr 19 2005 Dams <anvil[AT]livna.org> - 0:1.0-0.lvn.0.19.pre7
- Updated installstrip patch
- Updated ldconfig patch
- Updated to 1.0pre7

* Sun Feb 27 2005 Ville Skyttä <ville.skytta at iki.fi> 0:1.0-0.lvn.0.18.pre6a
- Fix PPC build (David Woodhouse, bug 376).
- Add libcaca support (rebuild "--without caca" to disable).
- Rebuild with LIRC support.

* Thu Jan  6 2005 Ville Skyttä <ville.skytta at iki.fi> 0:1.0-0.lvn.0.17.pre6a
- Update to 1.0pre6a (== 1.0pre6 + included HTML docs).
